function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/* eslint-env mocha */

/* global sinon */

/* eslint-disable prefer-arrow-callback */

/* eslint-disable no-unused-expressions */
import React from 'react';
import PropTypes from 'prop-types';
import chai, { expect } from 'chai';
import chaiEnzyme from 'chai-enzyme'; // `this.wrapper` and `this.dom` is set in the helpers file

import { mountComponent, unmountComponent } from '../../../tests/enzyme-helpers';
chai.use(chaiEnzyme());
import Icon from '../../icon';
import IconSettings from '../../icon-settings';

var DemoIcon =
/*#__PURE__*/
function (_React$Component) {
  _inherits(DemoIcon, _React$Component);

  function DemoIcon() {
    _classCallCheck(this, DemoIcon);

    return _possibleConstructorReturn(this, _getPrototypeOf(DemoIcon).apply(this, arguments));
  }

  _createClass(DemoIcon, [{
    key: "render",
    value: function render() {
      return React.createElement(Icon, this.props);
    }
  }]);

  return DemoIcon;
}(React.Component);

_defineProperty(DemoIcon, "displayName", 'DemoIcon');

describe('SLDSIcon: ', function () {
  describe('Standard Icon Props Render', function () {
    var svg;
    beforeEach(mountComponent(React.createElement(IconSettings, {
      iconPath: "/assets/icons"
    }, React.createElement(DemoIcon, {
      assistiveText: {
        label: 'Log a Call'
      },
      category: "standard",
      name: "log_a_call",
      style: {
        backgroundColor: 'rgb(218, 165, 32)'
      },
      size: "large"
    }))));
    afterEach(unmountComponent);
    it('renders container class', function () {
      expect(this.wrapper).to.have.className('slds-icon_container');
    });
    it('renders assistive text', function () {
      expect(this.wrapper.find('.slds-assistive-text')).to.have.text('Log a Call');
    });
    it('renders icon name class on svg', function () {
      // also tests that all '_' are replaced with '-'
      expect(this.wrapper).to.have.className('slds-icon-standard-log-a-call');
    });
    it('renders custom background color', function () {
      svg = this.wrapper.find('svg');
      expect(svg).to.have.style('backgroundColor', 'rgb(218, 165, 32)');
    });
    it('renders icon size class', function () {
      svg = this.wrapper.find('svg');
      expect(svg.hasClass('slds-icon_large')).to.be.true;
    });
  });
  describe('Custom Icon Props Render', function () {
    var svg;
    beforeEach(mountComponent(React.createElement(IconSettings, {
      iconPath: "/assets/icons"
    }, React.createElement(DemoIcon, {
      assistiveText: {
        label: 'Heart'
      },
      category: "custom",
      name: "custom1",
      size: "small"
    }))));
    afterEach(unmountComponent);
    it('renders container class', function () {
      expect(this.wrapper).to.have.className('slds-icon_container');
    });
    it('renders assistive text', function () {
      expect(this.wrapper.find('.slds-assistive-text')).to.have.text('Heart');
    });
    it('renders icon name class on svg', function () {
      // also tests that all '_' are replaced with '-'
      expect(this.wrapper).to.have.className('slds-icon-custom-custom1');
    });
    it('renders icon size class', function () {
      svg = this.wrapper.find('svg');
      expect(svg.hasClass('slds-icon_small')).to.be.true;
    });
  });
  describe('Action Icon Props Render', function () {
    var svg;
    beforeEach(mountComponent(React.createElement(IconSettings, {
      iconPath: "/assets/icons"
    }, React.createElement(DemoIcon, {
      assistiveText: {
        label: 'Announcements'
      },
      category: "action",
      name: "announcement",
      size: "large",
      title: "custom title",
      className: "slds-m-around_x-small"
    }))));
    afterEach(unmountComponent);
    it('renders container class', function () {
      expect(this.wrapper).to.have.className('slds-icon_container');
    });
    it('renders assistive text', function () {
      expect(this.wrapper.find('.slds-assistive-text')).to.have.text('Announcements');
    });
    it('renders round container', function () {
      expect(this.wrapper).to.have.className('slds-icon_container_circle');
    });
    it('renders icon name class on svg', function () {
      // also tests that all '_' are replaced with '-'
      expect(this.wrapper).to.have.className('slds-icon-action-announcement');
    });
    it('renders icon size class', function () {
      svg = this.wrapper.find('svg');
      expect(svg.hasClass('slds-icon_large')).to.be.true;
    });
    it('renders title', function () {
      expect(this.wrapper.find('[title="custom title"]')).to.exist;
    });
  });
  describe('Utility Icon Props Render', function () {
    var svg;
    beforeEach(mountComponent(React.createElement(IconSettings, {
      iconPath: "/assets/icons"
    }, React.createElement(DemoIcon, {
      category: "utility",
      name: "open_folder",
      size: "medium"
    }))));
    afterEach(unmountComponent);
    it('does NOT render container class', function () {
      expect(this.wrapper.hasClass('slds-icon_container')).to.be.false;
    });
    it('medium size does not render size class', function () {
      // also tests that all '_' are replaced with '-'
      expect(this.wrapper.hasClass('slds-icon_medium')).to.be.false;
    });
    it('utility icons do not render name class on svg', function () {
      // also tests that all '_' are replaced with '-'
      expect(this.wrapper.hasClass('slds-icon-text-default')).to.be.false;
    });
  });
  describe('Icon with external path renders', function () {
    var use;
    beforeEach(mountComponent(React.createElement(IconSettings, {
      iconPath: "/assets/icons"
    }, React.createElement(DemoIcon, {
      assistiveText: {
        label: 'New stuff!'
      },
      inverse: true,
      path: "/assets/icons/utility-sprite/svg/symbols.svg#announcement",
      size: "medium"
    }))));
    afterEach(unmountComponent);
    it('does NOT render slds-icon-standard class', function () {
      expect(this.wrapper.hasClass('slds-icon-standard-')).to.be.false;
    });
    it('path prop is passed to svg', function () {
      expect(this.wrapper.find('use')).to.have.attr('xlink:href', '/assets/icons/utility-sprite/svg/symbols.svg#announcement');
    });
  });
});
//# sourceMappingURL=icon.browser-test.js.map